<?php
include 'class.database.php';

/**
 * Klasa odpowiedzialna za logowanie do systemu
 */
class Login extends DataBase {
	
	// Przechowuje informację, czy użytkownik jest zalogowany (true), czy nie (false)
	protected $logged_in;	
	// Identyfikator zalogowanego użytkownika
	protected $user_id;		
	// Login użytkownika
	protected $login;
	// Przechowuje hasło użytkownika
	protected $md5_password;
	

   /**
	* Przechowuje numer dostępu zalogowanego użytkownika 
	* (np. 1 - można tylko pisać artykuły, 2 - można pisać artykuły i dodawać kategorie, sekcje,
	* 3 - można pisać artykuły, dodawać kategorie, sekcje i tworzyć konta,
	* 4 - można pisać artykuły, dodawać kategorie, sekcje, tworzyć konta i projektować menu).
	*/
	protected $access;
	
	
	/**
	 * Konstruktor klasy Login
	 */
	public function __construct() {
		parent::__construct();
		session_start();
		
		if (!empty($_SESSION['username']) && !empty($_SESSION['password'])) {
			$this->login = addslashes($_SESSION['username']);
			$this->md5_password = addslashes($_SESSION['password']);
			$sql = "SELECT id_uzytkownik, uprawnienie FROM uzytkownicy WHERE login = '$this->login' AND md5_haslo = '$this->md5_password'";
			$result = $this->mMysqli->query($sql);
			
			if ($result->num_rows > 0) {
				$row = $result->fetch_array(MYSQLI_ASSOC);
				$this->user_id = $row["id_uzytkownik"];
				$this->logged_in = true;
				$this->access = $row["uprawnienie"];
			}
		}
		
	} // Koniec konstruktora
	
	/**
	 * Metoda odpowiedzialna za zalogowanie użytkownika do systemu
	 */
	public function userLogin($str_username, $str_password) {
		$this->login = addslashes($str_username);
		$this->md5_password = md5($str_password);
		$_SESSION['username'] = $str_username;
		$_SESSION['password'] = $this->md5_password;
		
		$sql = "SELECT id_uzytkownik, uprawnienie FROM uzytkownicy WHERE login = '$this->login' AND md5_haslo = '$this->md5_password'";
		$result = $this->mMysqli->query($sql);
		
		if($result->num_rows > 0) {
			
			$row = $result->fetch_array(MYSQLI_ASSOC);
			$this->user_id = $row["id_uzytkownik"];
			$this->logged_in = true;
			$this->access = $row["uprawnienie"];
			
			return true;
		} else {
			return false;
		}
	} // Koniec metody userLogin()
	
	/**
	 * Metoda odpowiedzialna za wylogowanie użytkownika z systemu
	 */
	public function logout() {
		if ($this->logged_in == true) {
			// Przy wylogowaniu należy wyczyścić wszystkie ustawienia użytkownika
			$this->logged_in = false;
			$this->user_id = 0;
			$this->access = 0;
			
			session_destroy();
			
			return true;
		} else {
			return false;
		}
	} // Koniec metody logout()
	
	/**
	 * Metoda sprawdzająca, czy użytkownik jest zalogowany
	 */
	public function isLoggedIn() {
		return $this->logged_in;
	} // Koniec metody isLoggedIn()
	
	/**
	 * Metoda pobiera ID zalogowanego użytkownika
	 */
	public function getUserId() {
		if ($this->logged_in) {
			return $this->user_id;
		} else {
			return false;
		}
	} // Koniec metody getUserId()
	
} // Koniec klasy Login